/****************************************************************************
 *	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	sample_0010.cpp
 *
 *	@brief	MME𗘗pTEh̓vO.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <commctrl.h>
#include <tchar.h>
#include "resource.h"
#include "WaveFile.h"

// V{`.
#define	SMPFRQ			48000				//!< TvOg.
#define	BUFSIZE			((SMPFRQ * 4) / 10)	//!< f[^obt@TCY (100ms).

// ֐vg^Cv.
static LRESULT CALLBACK	SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
static void				OnInitDialog( HWND hDlg );
static BOOL				OnSelectFile( HWND hDlg );
static BOOL				RecSound( HWND hDlg );
static void				PauseSound( HWND hDlg );
static void				StopSound( HWND hDlg );
static BOOL				OpenSoundInputDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundInputDevice( void );
static void				SoundInputDone( HWND hDlg, WAVEHDR* wh );
static BOOL				OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundOutputDevice( void );
static void				SoundOutputDone( HWND hDlg, WAVEHDR* wh );
static DWORD			VolumeControl( HWND hVolume );

// [Jϐ.
static BOOL			RecFlag;				//!< TRUE = ^.
static BYTE*		DataBuff;				//!< f[^obt@.
static DWORD		DataSize;				//!< f[^TCY.
static HWAVEOUT		hWO;					//!< TEho̓foCX̃nh.
static WAVEHDR		OutHdr[2];				//!< TEho͂̃f[^ubN\.
static HWAVEIN		hWI;					//!< TEh̓foCX̃nh.
static WAVEHDR		InHdr[2];				//!< TEh͂̃f[^ubN\.
static TCHAR		FileName[MAX_PATH+1];	//!< ^WAVt@C̃t@C.

/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	//! [Jϐ.
	RecFlag = FALSE;
	hWO     = NULL;
	hWI     = NULL;
	memset( OutHdr  , 0, sizeof(OutHdr)   );
	memset( InHdr   , 0, sizeof(InHdr)    );
	memset( FileName, 0, sizeof(FileName) );

	//! RRg[.
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC  = ICC_COOL_CLASSES;
	InitCommonControlsEx( &ic );

	//! _CAOI[v.
	DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)SoundOutProc );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	_CAÕbZ[WEnh.
 *
 *	@param	[in]	hDlg	_CAO{bNX̃nh.
 *	@param	[in]	msg		bZ[W.
 *	@param	[in]	wParam	ŏ̃bZ[Wp[^.
 *	@param	[in]	lParam	2Ԗڂ̃bZ[Wp[^.
 *
 *	@retval	TRUE  = bZ[W.
 *	@retval	FALSE = bZ[WȂ.
 */
static LRESULT CALLBACK		SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ){
	case WM_INITDIALOG:
		OnInitDialog( hDlg );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_FILE_SELECT:
			OnSelectFile( hDlg );
			break;

		case IDC_REC:
			if( !RecSound( hDlg ) ){
				StopSound( hDlg );
			}
			break;

		case IDC_PAUSE:
			PauseSound( hDlg );
			break;

		case IDC_STOP:
			StopSound( hDlg );
			break;

		case IDCANCEL:
			StopSound( hDlg );
			EndDialog( hDlg, 0 );
			break;

		default:
			return FALSE;
		}
		break;

	case MM_WOM_DONE:
		SoundOutputDone( hDlg, (WAVEHDR*)lParam );
		break;

	case MM_WIM_DATA:
		SoundInputDone( hDlg, (WAVEHDR*)lParam );
		break;

	case WM_VSCROLL:
		if( GetDlgItem( hDlg, IDC_VOLUME ) == (HWND)lParam ){
			VolumeControl( (HWND)lParam );
		}
		break;

	default:
		break;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	_CAȌ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		OnInitDialog( HWND hDlg )
{
	//! o̓foCXXg쐬.
	DWORD dev_num = waveOutGetNumDevs();
	if( dev_num != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_OUTPUT_DEVICE );

		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < dev_num; i++ ){
			// o̓foCX̐\擾.
			WAVEOUTCAPS caps;
			if( waveOutGetDevCaps( i, &caps, sizeof(caps) ) == MMSYSERR_NOERROR ){
				ComboBox_AddString( hlist, caps.szPname );
			}
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	//! ̓foCXXg쐬.
	dev_num = waveInGetNumDevs();
	if( dev_num != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_INPUT_DEVICE );

		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < dev_num; i++ ){
			// ̓foCX̐\擾.
			WAVEINCAPS caps;
			if( waveInGetDevCaps( i, &caps, sizeof(caps) ) == MMSYSERR_NOERROR ){
				ComboBox_AddString( hlist, caps.szPname );
			}
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	//! ʃ{[̃gbNo[ݒ肷.
	HWND hbar = GetDlgItem( hDlg, IDC_VOLUME );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );
}

/****************************************************************************/
/*!
 *	@brief	^WAVt@CI.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static BOOL		OnSelectFile( HWND hDlg )
{
	//! ^WAVt@Ct@CI_CAOI.
	OPENFILENAME ofn;
	memset( &ofn     , 0, sizeof(ofn)      );
	memset( &FileName, 0, sizeof(FileName) );
	ofn.lStructSize    = sizeof(ofn);
	ofn.hwndOwner      = hDlg;
	ofn.lpstrFilter    = _T("WAVEt@C(*.wav)\0*.wav\0SẴt@C(*.*)\0*.*\0\0");
	ofn.lpstrFile      = FileName;
	ofn.nMaxFile       = MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt    = NULL;
	ofn.lpstrTitle     = _T("^t@C");
	if( GetSaveFileName( &ofn ) ){
		SetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName );
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	O̘^Jn.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		RecSound( HWND hDlg )
{
	if( !hWI ){
		//! I[fBIEf[^EtH[}bgݒ肷.
		WAVEFORMATEX wf;
		wf.wFormatTag      = WAVE_FORMAT_PCM;
		wf.nChannels       = 2;
		wf.wBitsPerSample  = 16;
		wf.nBlockAlign     = 4;
		wf.nSamplesPerSec  = SMPFRQ;
		wf.nAvgBytesPerSec = SMPFRQ * wf.nBlockAlign;
		wf.cbSize          = 0;

		//! _CAOĐWAVt@C擾.
		GetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName, sizeof(FileName) - 1 );

		//! ۑWAVt@CVK쐬ŃI[v.
		int result = SaveOpenWaveFile( FileName, &wf, FALSE );
		if( result == -2 ){
			//! ̃t@CꍇA㏑邩ǂ₢킹.
			if( MessageBox( hDlg, _T("Ƀt@C݂Ă܂B㏑܂H"), _T("WAVt@C̕ۑ"), MB_YESNO ) == IDYES ){

				//! ㏑[hŃt@CI[v.
				result = SaveOpenWaveFile( FileName, &wf, TRUE );
			}else{
				return FALSE;
			}
		}
		if( result != 0 ){
			MessageBox( hDlg, _T("t@CI[vł܂"), _T("WAVt@C̕ۑ"), MB_OK );
			return FALSE;
		}

		//! TEh̓foCXI[v.
		UINT num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_INPUT_DEVICE ) );
		if( !OpenSoundInputDevice( hDlg, num, &wf ) ){
			return FALSE;
		}
		//! TEho̓foCXI[v.
		num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ) );
		if( !OpenSoundOutDevice( hDlg, num, &wf ) ){
			return FALSE;
		}
		//! {[ݒ_CAO̐ݒɂ킹.
		VolumeControl( GetDlgItem( hDlg, IDC_VOLUME ) );

		//! TEh̓obt@Zbg.
		waveInReset( hWI );

		//! f[^ubNTEh̓foCXɃL[CO.
		for( DWORD i = 0; i < 2; i++ ){
			InHdr[i].dwBytesRecorded = 0;
			waveInAddBuffer( hWI, &InHdr[i], sizeof(WAVEHDR) );
		}

		//! TEh͏Jn.
		waveInStart( hWI );
	}
	//! ^撆tOZbg.
	RecFlag = TRUE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), FALSE );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	O̘^ꎞ~.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		PauseSound( HWND hDlg )
{
	//! ^撆tONA.
	RecFlag = FALSE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	O̘^~.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		StopSound( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundOutputDevice();

	//! TEh̓foCXN[Y.
	CloseSoundInputDevice();

	//! WAVt@CN[Y.
	CloseWaveFile();

	//! ^撆tONA.
	RecFlag = FALSE;

	EnableWindow( GetDlgItem( hDlg, IDC_REC           ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_INPUT_DEVICE  ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	TEh̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundInputDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! ̓foCXI[v.
	if( waveInOpen( &hWI, num, wf, (DWORD)hDlg, 0, CALLBACK_WINDOW ) != MMSYSERR_NOERROR ){
		return FALSE;
	}
	//! f[^ubN̓foCXɓo^.
	memset( InHdr, 0, sizeof(InHdr) );
	for( int i = 0; i < 2; i++ ){
		InHdr[i].lpData         = new char[BUFSIZE];
		InHdr[i].dwBufferLength = BUFSIZE;
		if( waveInPrepareHeader( hWI, &InHdr[i], sizeof(WAVEHDR) ) != MMSYSERR_NOERROR ){
			return FALSE;
		}
	}
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEh̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundInputDevice( void )
{
	if( hWI ){
		//! -1.TEh͂~.
		waveInStop( hWI );

		for( int i = 0; i < 2; i++ ){
			//! -2.̓foCXɓo^f[^ubN.
			waveInUnprepareHeader( hWI, &InHdr[i], sizeof(WAVEHDR) );

			//! -3.f[^obt@.
			if( InHdr[i].lpData ){
				delete [] InHdr[i].lpData;
				InHdr[i].lpData = NULL;
			}
		}
		//! -4.̓foCXN[Y.
		waveInClose( hWI );
		hWI = NULL;
	}
}

/****************************************************************************/
/*!
 *	@brief	TEh̓f[^̎捞݊ʒm.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	wh		f[^ubN\̂̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		SoundInputDone( HWND hDlg, WAVEHDR* wh )
{
	if( hWI ){
		if( wh->dwBytesRecorded > 0 ){

			//! ^撆̏ꍇ̂WAVt@Cɓ͉f[^ۑ.
			if( RecFlag ){
				if( WritedWaveFile( wh->lpData, wh->dwBytesRecorded ) == 0 ){
					CloseWaveFile();
				}
			}

			//! 󂢂Ăo̓f[^obt@TāA͉f[^Rs[.
			for( DWORD i = 0; i < 2; i++ ){
				if( OutHdr[i].dwBufferLength == 0 && OutHdr[i].lpData ){
					memcpy( OutHdr[i].lpData, wh->lpData, wh->dwBytesRecorded );
					OutHdr[i].dwBufferLength = wh->dwBytesRecorded;
					waveOutWrite( hWO, &OutHdr[i], sizeof(WAVEHDR) );
					break;
				}
			}

			//! foCXɋ󂢂̓obt@L[CO.
			wh->dwBytesRecorded = 0;
			waveInAddBuffer( hWI, wh, sizeof(WAVEHDR) );
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! o̓foCXI[v.
	if( waveOutOpen( &hWO, num, wf, (DWORD)hDlg, 0, CALLBACK_WINDOW ) != MMSYSERR_NOERROR ){
		return FALSE;
	}
	//! f[^ubNo̓foCXɓo^.
	memset( OutHdr, 0, sizeof(OutHdr) );
	for( int i = 0; i < 2; i++ ){
		OutHdr[i].lpData = new char[BUFSIZE];
		if( waveOutPrepareHeader( hWO, &OutHdr[i], sizeof(WAVEHDR) ) != MMSYSERR_NOERROR ){
			return FALSE;
		}
	}
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundOutputDevice( void )
{
	if( hWO ){
		//! -1.TEho͂~.
		waveOutReset( hWO );

		for( int i = 0; i < 2; i++ ){
			//! -2.o̓foCXɓo^f[^ubN.
			waveOutUnprepareHeader( hWO, &OutHdr[i], sizeof(WAVEHDR) );

			//! -3.f[^obt@.
			if( OutHdr[i].lpData ){
				delete [] OutHdr[i].lpData;
				OutHdr[i].lpData = NULL;
			}
		}
		//! -4.o̓foCXN[Y.
		waveOutClose( hWO );
		hWO = NULL;
	}
}

/****************************************************************************/
/*!
 *	@brief	TEho̓f[^̏o͊ʒm.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	wh		f[^ubN\̂̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		SoundOutputDone( HWND hDlg, WAVEHDR* wh )
{
	if( hWO ){
		//! TEho͂f[^̃oCgf[^ubNɃZbg.
		wh->dwBufferLength = 0;
	}
}

/****************************************************************************/
/*!
 *	@brief	ʃ{[ݒύX.
 *
 *	@param	[in]	hVolume	{[Rg[o[̃nh.
 *
 *	@retval	V{[ݒl.
 */
static DWORD	VolumeControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇA{[ݒsȂ.
	if( !hWO ){
		return 0;
	}
	//! _CAO{[Rg[̈ʒu擾.
	DWORD range  = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	DWORD volume = ((100 - range) * 0xFFFF) / 100;

	//! {[ݒύX.
	DWORD wk_vol = ((volume << 16) & 0xFFFF0000) + (volume & 0xFFFF);
	if( waveOutSetVolume( hWO, wk_vol ) != MMSYSERR_NOERROR ){
		return 0;
	}
	return volume;
}

/* End of file */
